#!/usr/bin/python
# -*- coding: utf-8 -*-

# Copyright (C) 1994  Ling Li
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.


import string

class FTPException(Exception):
    def __init__(self, resp):
        if not isinstance(resp, str):
            resp = resp.__str__()
        errno = string.atoi(resp[0:3])
        errmsg = resp[4:]
        self.args = (errno, errmsg)

class NetworkException(Exception):
    def __init__(self, resp):
        self.args = resp

class FTPPermException(FTPException):
    def __init__(self, resp):
        FTPException.__init__(self, resp)

class FTPTempException(FTPException):
    def __init__(self, resp):
        FTPException.__init__(self, resp)
        
class FTPInterruptedException(FTPException): pass
class FTPEngineBusyException(FTPException): pass

